%---------------------------------------------------------------
% *** 2.161 Signal Processing - Continuous and Discrete ***
%			Tutorial MATLAB Function
%
% ifftx - Tutorial inverse FFT routine to demonstrate the Radix-2
% 		inverseFFT using a forward FFT routine.
%
% Source:	Class handout: The Fast Fourier Transform
%
% Usage:	fout = ifftx(F, k)
% 		where	F - frequency domain data set
% 			k - size of the data set k = log_2(N)
%
% Author: D. Rowell
% Revision: 1.0 10-1-2007
%
%---------------------------------------------------------------
function fout = ifftx(F,ksize)
N = 2^ksize;
%
% Conjugate the input data
fout=conj(F);
% Take the forward FFT, conjugate and divide by N
fout =demofft(fout,ksize);
fout=conj(fout)/N;